Onlyoffice文件大小限制
# 1 前言
Onlyoffice默认初始文件上线为100MB，超过100MB的文件在example中会无法上传。打开文件的时候会报错“文件超出大小限制”
文件越大，onlyoffice效率会越低，所以尽量将大小设置在1GB内，即1000MB
注意，所有配置规则修改后一定要重启四大服务。所有配置规则修改后只对新上传的文件才有效。
# 2 Example报错
## 2.1 413 (Request Entity Too Large)
## 2.1.1 错误描述
![](/uploads/onlyoffice/images/m_f0024c5e7088de14f2f7f6c8f52d6f9e_r.png)
带413状态码的请求实体过大
这种情况通常发生在请求文件过大（不包含参数）的情况下。客户端发送的请求实体超过服务器所能处理的最大限制，服务器会返回413状态码提示请求实体过大。
## 2.1.2 解决方案
1. 定位到目录“ONLYOFFICE\DocumentServer\nginx\conf\includes”，打开“ds-common.conf”
![](/uploads/onlyoffice/images/m_e7a20759b4bc657741dfe4c981cbb9b5_r.png)
2. 将client_max_body_size设置到1000M，保存后重启四大服务即可
![](/uploads/onlyoffice/images/m_a31b57c74a3576de6ad1c50fea4ba04d_r.png)
## 2.2 MaxFileSize exceeded
### 2.2.1 错误描述
![](/uploads/onlyoffice/images/m_03597bb4391daa0e9442c674d4fa0f1b_r.png)
上传文件大小超出可最大限制
### 2.2.2 解决方案
1. 定位到目录“ONLYOFFICE\DocumentServer\example\config”，打开“default.json”
![](/uploads/onlyoffice/images/m_e48a4cc823cba74766846b05e9f319f9_r.png)
2. 修改“maxFileSize”值为“1043471824”，表示最大上线为1000M
![](/uploads/onlyoffice/images/m_b2b77c5cd6779b7d4a65eb3716ea741c_r.png)
3. 定位到目录“ONLYOFFICE\DocumentServer\example\config”，打开“production-windows.json”
![](/uploads/onlyoffice/images/m_57adca2172c5e38c9642348ac1734b69_r.png)
4. 修改“maxFileSize”值为“1043471824”，表示最大上线为1000M
![](/uploads/onlyoffice/images/m_cd61920fada4945871207fb20d9e2570_r.png)
# 3 DocumentServer报错
## 3.1 文件大小限制
### 3.1.1 错误描述
![](/uploads/onlyoffice/images/m_3a8c8194c14cc2411c3feca4ea4f769e_r.png)
打开文档提示“文件大小超出了为服务器设置的限制”
### 3.1.2 解决方案
1. 定位到目录“ONLYOFFICE\DocumentServer\config”，打开文件“default.json”
![](/uploads/onlyoffice/images/m_fc43ef389644cfa9bd4fb5beb426fc17_r.png)
2. 修改“limits_tempfile_upload”值为“1043471824”
![](/uploads/onlyoffice/images/m_469666f41dca3be6dadeef264ac84e88_r.png)
3. 修改“maxDownloadBytes”值为“1043471824”，修改“uncompressed”值为“1000MB”
![](/uploads/onlyoffice/images/m_65f7dc4bfcc45ddf354b846aac2ad1bc_r.png)